Ginkgo: gko::batch::matrix::Identity< ValueType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::batch::matrix::Identity< ValueType > Class Template Referencefinal
Linear Operators » SpMV employing different Matrix formats | BatchLinOp

The batch Identity matrix, which represents a batch of Identity matrices. More...

`#include <ginkgo/core/matrix/batch_identity.hpp>`

Inheritance diagram for gko::batch::matrix::Identity< ValueType >:
[legend]
Collaboration diagram for gko::batch::matrix::Identity< ValueType >:
[legend]

## Public Types
using | value_type = ValueType
using | index_type = int32
using | unbatch_type = gko::matrix::Identity<ValueType>
using | absolute_type = remove_complex<Identity>
using | complex_type = to_complex<Identity>
Public Types inherited from gko::EnablePolymorphicAssignment< Identity< default_precision > >
using | result_type

## Public Member Functions
Identity * | apply (ptr_param< const MultiVector< value_type > > b, ptr_param< MultiVector< value_type > > x)
| Apply the matrix to a multi-vector.
Identity * | apply (ptr_param< const MultiVector< value_type > > alpha, ptr_param< const MultiVector< value_type > > b, ptr_param< const MultiVector< value_type > > beta, ptr_param< MultiVector< value_type > > x)
| Apply the matrix to a multi-vector with a linear combination of the given input vector.
const Identity * | apply (ptr_param< const MultiVector< value_type > > b, ptr_param< MultiVector< value_type > > x) const
const Identity * | apply (ptr_param< const MultiVector< value_type > > alpha, ptr_param< const MultiVector< value_type > > b, ptr_param< const MultiVector< value_type > > beta, ptr_param< MultiVector< value_type > > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Identity< default_precision > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
static std::unique_ptr< Identity > | create (std::shared_ptr< const Executor > exec, const batch_dim< 2 > &size=batch_dim< 2 >{})
| Creates an Identity matrix of the specified size.

## Friends
class | EnablePolymorphicObject< Identity, BatchLinOp >

## Detailed Description

template<typename ValueType = default_precision>
class gko::batch::matrix::Identity< ValueType >

The batch Identity matrix, which represents a batch of Identity matrices.

Template Parameters

  ValueType | precision of matrix elements

## Member Function Documentation

## ◆ apply() [1/4]

template<typename ValueType = default_precision>

Identity * gko::batch::matrix::Identity< ValueType >::apply | ( | ptr_param< const MultiVector< value_type > > | alpha,
|  | ptr_param< const MultiVector< value_type > > | b,
|  | ptr_param< const MultiVector< value_type > > | beta,
|  | ptr_param< MultiVector< value_type > > | x )

Apply the matrix to a multi-vector with a linear combination of the given input vector.

Represents the matrix vector multiplication, x = alpha * I

- b + beta * x, where x and b are both multi-vectors.

Parameters

  alpha | the scalar to scale the matrix-vector product with
  b | the multi-vector to be applied to
  beta | the scalar to scale the x vector with
  x | the output multi-vector

## ◆ apply() [2/4]

template<typename ValueType = default_precision>

const Identity * gko::batch::matrix::Identity< ValueType >::apply | ( | ptr_param< const MultiVector< value_type > > | alpha,
|  | ptr_param< const MultiVector< value_type > > | b,
|  | ptr_param< const MultiVector< value_type > > | beta,
|  | ptr_param< MultiVector< value_type > > | x ) const

## ◆ apply() [3/4]

template<typename ValueType = default_precision>

Identity * gko::batch::matrix::Identity< ValueType >::apply | ( | ptr_param< const MultiVector< value_type > > | b,
|  | ptr_param< MultiVector< value_type > > | x )

Apply the matrix to a multi-vector.

Represents the matrix vector multiplication, x = I * b, where x and b are both multi-vectors.

Parameters

  b | the multi-vector to be applied to
  x | the output multi-vector

## ◆ apply() [4/4]

template<typename ValueType = default_precision>

const Identity * gko::batch::matrix::Identity< ValueType >::apply | ( | ptr_param< const MultiVector< value_type > > | b,
|  | ptr_param< MultiVector< value_type > > | x ) const

## ◆ create()

template<typename ValueType = default_precision>

std::unique_ptr< Identity > gko::batch::matrix::Identity< ValueType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const batch_dim< 2 > & | size = batch_dim< 2 >{} )
| static

Creates an Identity matrix of the specified size.

Parameters

  exec | Executor associated to the matrix
  size | size of the batch matrices in a batch_dim object

Returns
  A smart pointer to the newly created matrix.

The documentation for this class was generated from the following file:

- ginkgo/core/matrix/batch_identity.hpp